pub fn part_one(input_lines: Vec<String>) -> String {
    let mut result: i32 = 0;

    for line in input_lines {
        let nums = parse_line(&line);

        let mut last: Vec<i32> = Vec::new();
        last.push(nums.last().unwrap().clone());

        let mut diffs = get_differences(nums.clone());
        last.push(diffs.last().unwrap().clone());

        while !all_zeros(diffs.clone()) {
            diffs = get_differences(diffs.clone());
            last.push(diffs.last().unwrap().clone());
        }

        result += last.iter().sum::<i32>();
    }

    result.to_string()
}

fn parse_line(s: &str) -> Vec<i32> {
    s.split_whitespace().map(|x| x.parse().unwrap()).collect()
}

fn get_differences(nums: Vec<i32>) -> Vec<i32> {
    nums.windows(2).map(|w| w[1] - w[0]).collect()
}

fn all_zeros(nums: Vec<i32>) -> bool {
    nums.iter().all(|&x| x == 0)
}